<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>FreeRefFunction (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="FreeRefFunction (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":6};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/FreeRefFunction.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../../org/apache/poi/ss/formula/functions/Fixed4ArgFunction.html"
               title="class in org.apache.poi.ss.formula.functions"><span
                class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../../org/apache/poi/ss/formula/functions/Frequency.html"
               title="class in org.apache.poi.ss.formula.functions"><span
                class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../../index.html?org/apache/poi/ss/formula/functions/FreeRefFunction.html"
               target="_top">Frames</a></li>
        <li><a href="FreeRefFunction.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.ss.formula.functions</div>
    <h2 title="Interface FreeRefFunction" class="title">Interface FreeRefFunction</h2>
</div>
<div class="contentContainer">
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Known Implementing Classes:</dt>
                    <dd><a href="../../../../../../org/apache/poi/ss/formula/functions/Bin2Dec.html"
                           title="class in org.apache.poi.ss.formula.functions">Bin2Dec</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/Complex.html"
                            title="class in org.apache.poi.ss.formula.functions">Complex</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/Countifs.html"
                            title="class in org.apache.poi.ss.formula.functions">Countifs</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/Dec2Bin.html"
                            title="class in org.apache.poi.ss.formula.functions">Dec2Bin</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/Dec2Hex.html"
                            title="class in org.apache.poi.ss.formula.functions">Dec2Hex</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/Delta.html"
                            title="class in org.apache.poi.ss.formula.functions">Delta</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/EDate.html"
                            title="class in org.apache.poi.ss.formula.functions">EDate</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/EOMonth.html"
                            title="class in org.apache.poi.ss.formula.functions">EOMonth</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/FactDouble.html"
                            title="class in org.apache.poi.ss.formula.functions">FactDouble</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/Hex2Dec.html"
                            title="class in org.apache.poi.ss.formula.functions">Hex2Dec</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/Imaginary.html"
                            title="class in org.apache.poi.ss.formula.functions">Imaginary</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/ImReal.html"
                            title="class in org.apache.poi.ss.formula.functions">ImReal</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/Indirect.html"
                            title="class in org.apache.poi.ss.formula.functions">Indirect</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/Oct2Dec.html"
                            title="class in org.apache.poi.ss.formula.functions">Oct2Dec</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/Quotient.html"
                            title="class in org.apache.poi.ss.formula.functions">Quotient</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/Sumifs.html"
                            title="class in org.apache.poi.ss.formula.functions">Sumifs</a>, <a
                            href="../../../../../../org/apache/poi/ss/formula/functions/WeekNum.html"
                            title="class in org.apache.poi.ss.formula.functions">WeekNum</a></dd>
                </dl>
                <hr>
                <br>
                <pre>public interface <span class="typeNameLabel">FreeRefFunction</span></pre>
                <div class="block">For most Excel functions, involving references ((cell, area), (2d, 3d)), the
                    references are
                    passed in as arguments, and the exact location remains fixed. However, a select few Excel
                    functions have the ability to access cells that were not part of any reference passed as an
                    argument.<br>
                    Two important functions with this feature are <b>INDIRECT</b> and <b>OFFSET</b>
                    <p>

                        When POI evaluates formulas, each reference argument is capable of evaluating any cell inside
                        its range. Actually, even cells outside the reference range but on the same sheet can be
                        evaluated. This allows <b>OFFSET</b> to be implemented like most other functions - taking only
                        the arguments, and source cell coordinates.

                        For the moment this interface only exists to serve the <b>INDIRECT</b> which can decode
                        arbitrary text into cell references, and evaluate them..</div>
                <dl>
                    <dt><span class="simpleTagLabel">Author:</span></dt>
                    <dd>Josh Micich</dd>
                </dl>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a
                                    href="javascript:show(4);">Abstract Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../../org/apache/poi/ss/formula/functions/FreeRefFunction.html#evaluate-org.apache.poi.ss.formula.eval.ValueEval:A-org.apache.poi.ss.formula.OperationEvaluationContext-">evaluate</a></span>(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>[]&nbsp;args,
                                    <a href="../../../../../../org/apache/poi/ss/formula/OperationEvaluationContext.html"
                                       title="class in org.apache.poi.ss.formula">OperationEvaluationContext</a>&nbsp;ec)</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="evaluate-org.apache.poi.ss.formula.eval.ValueEval:A-org.apache.poi.ss.formula.OperationEvaluationContext-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>evaluate</h4>
                                <pre><a href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>&nbsp;evaluate(<a
                                        href="../../../../../../org/apache/poi/ss/formula/eval/ValueEval.html"
                                        title="interface in org.apache.poi.ss.formula.eval">ValueEval</a>[]&nbsp;args,
                   <a href="../../../../../../org/apache/poi/ss/formula/OperationEvaluationContext.html"
                      title="class in org.apache.poi.ss.formula">OperationEvaluationContext</a>&nbsp;ec)</pre>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>args</code> - the pre-evaluated arguments for this function. args is never
                                        <code>null</code>,
                                        nor are any of its elements.
                                    </dd>
                                    <dd><code>ec</code> - primarily used to identify the source cell containing the
                                        formula being evaluated.
                                        may also be used to dynamically create reference evals.
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>never <code>null</code>. Possibly an instance of <tt>ErrorEval</tt> in the case
                                        of
                                        a specified Excel error (Exceptions are never thrown to represent Excel errors).
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/FreeRefFunction.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../../org/apache/poi/ss/formula/functions/Fixed4ArgFunction.html"
               title="class in org.apache.poi.ss.formula.functions"><span
                class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../../org/apache/poi/ss/formula/functions/Frequency.html"
               title="class in org.apache.poi.ss.formula.functions"><span
                class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../../index.html?org/apache/poi/ss/formula/functions/FreeRefFunction.html"
               target="_top">Frames</a></li>
        <li><a href="FreeRefFunction.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li>Constr&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
